.globl task_switch

// This function takes a pointer
// to a PROC structure and jump
// to this process
task_switch:
    push 12(%esi)  # eax (cf PROC struct)
    push 16(%esi)  # ebx
    push 20(%esi)  # ecx
    push 24(%esi)  # edx
    push 44(%esi)  # ebp
    push 48(%esi)  # esi
    push 52(%esi)  # edi
    push 56(%esi)  # ds
    push 60(%esi)  # es
    push 64(%esi)  # fs
    push 68(%esi)  # gs

    // Don't forget to clear the interrupt
    movb $0x20, %al
    outb %al, $0x20

    // Setup process page directory
    mov 8(%esi), %eax
    mov %eax, %cr3

    // Setup registers
    pop %gs
    pop %fs
    pop %es
    pop %ds
    pop %edi
    pop %esi
    pop %ebp
    pop %edx
    pop %ecx
    pop %ebx
    pop %eax

    // Perform the task switch
    push 36(%esi)  # ss
    push 40(%esi)  # esp
    push 72(%esi)  # eflags
    push 28(%esi)  # cs
    push 32(%esi)  # eip
    iret
